<?php
	$pmp_rel_path = '..';
	$pmp_module = 'admin_report';
	require_once('../config.inc.php');
	require_once('../functions.php');
	require_once('../include/smallDVD.class.php');
	define('FPDF_FONTPATH',$pmp_rel_path.'/include/font/');
	require_once('../include/fpdf.php');

	isadmin();
	
class PDF extends FPDF
{

	function Header($evenonpageone = False)
	{
		if($evenonpageone || $this->PageNo() != 1)
		{
			//Colors, line width and bold font
			$this->SetFillColor(150,150,150);
			$this->SetTextColor(255);
			$this->SetDrawColor(200,200,200);
			$this->SetLineWidth(.3);
			$this->SetFont('','B');
			
			for($i=0;$i<count($this->header);$i++)
		    $this->Cell($this->colwidth[$i],7,$this->truncTT($this->header[$i], $this->colwidth[$i]),1,0,'C',1);
			$this->Ln();
		}
		
	}
	
	function truncTT($string, $width, $suffix = '...')
	{
		
		if($this->GetStringWidth($string) > $width)
		{ //echo "$string<br />";
			if($suffix != '')
				return $this->truncTT(substr($string, 0, strlen($string) - 2) . $suffix, $width, '');
			else
				return $this->truncTT(substr($string, 0, strlen($string) - 5) . '...', $width, '');
		}
		else
			return $string;
		
	}
	
	//Colored table
	function generateReport($header, $colwidth, $data)
	{
		global $pmp_version;
		$this->header = $header;
		$this->SetFont('Arial','',10);

		$ColCount = count($data[1]);
		// Durchschnittsbreite
		$MaxWidth = $this->w - $this->lMargin - $this->rMargin;
		$AvgWidth = $MaxWidth / $ColCount;
		
		// Maximalbreiten pro Spalte ermitteln
		for($i=0; $i < count($data); $i++)
		{
			for($j=0; $j < count($data[$i]); $j++)
			{
				$l = $this->GetStringWidth($data[$i][$j])+2;
				$max[$j] = ($l > $max[$j]) ? $l : $max[$j];
				
			}
		}
		
		$reqWidth = array_sum($max);
		
		// Haben wir Platz brig?
		if($reqWidth < $MaxWidth) 
		{
			// Platz gleichmig verteilen
			$unused = $MaxWidth - $reqWidth;
			for($i=0; $i< count($max); $i++)
			{
				$colWidth[$i] = $max[$i] + $unused / $ColCount;
			}
		}
		else
		{
			// Platz gleichmig verteilen
			$saveWidth = $reqWidth - $MaxWidth;
			
			for($i=0; $i< count($max); $i++)
			{
				if($max[$i] == max($max))
				{
					$colWidth[$i] = $max[$i] - $saveWidth;
				}
				else
				{
					$colWidth[$i] = $max[$i];
				}
			}
		}
			
		$this->colwidth = $colWidth;

		$this->SetFont('Arial','',20);
		$this->write(10, t("DVD list") . "\n");
		$this->SetFont('Arial','',10);
		
		$this->Header(True);
		
		$this->SetTextColor(0);
		$this->SetFont('');

		$fill=True;
		foreach($data as $row)
		{
			if($fill)
			{
				$this->SetFillColor(200,200,200);
			}
			else
			{
				$this->SetFillColor(255, 255, 255);
			}
			

			for($i=0; $i< count($this->colwidth); $i++)
			{
				$this->Cell($this->colwidth[$i], 5, $this->truncTT($row[$i], $this->colwidth[$i]) , 'LRB', 0, 'L', 1);	
			}
			$this->SetFillColor(255, 255, 255);
			//$this->Cell(20, 5, '', 'L', 0, 'L', 1);	
			$this->Ln();
			$fill=!$fill;
		}

		$this->SetFont('Arial','' , 6);
		$this->SetX($this->w - $this->rMargin  - $this->GetStringWidth(t('Generated by ') . t('phpmyProfiler V') . $pmp_version) - 3);
		$this->Write(6, t('Generated by '));
		$this->SetFont('', 'U');
		$this->write(6, t('phpmyProfiler ') . $pmp_version, 'http://www.phpmyprofiler.de');
	}
}

	unset($header);	
	if($_POST['report'] == 'pdf')
	{
		if(!empty($_POST['col1'])) $header[0] = decode_entities(t(getColumns($_POST['col1'], 'Header')));
		if(!empty($_POST['col2'])) $header[1] = decode_entities(t(getColumns($_POST['col2'], 'Header')));
		if(!empty($_POST['col3'])) $header[2] = decode_entities(t(getColumns($_POST['col3'], 'Header')));
		if(!empty($_POST['col4'])) $header[3] = decode_entities(t(getColumns($_POST['col4'], 'Header')));
		if(!empty($_POST['col5'])) $header[4] = decode_entities(t(getColumns($_POST['col5'], 'Header')));
		if(!empty($_POST['col6'])) $header[5] = decode_entities(t(getColumns($_POST['col6'], 'Header')));
	}
	else
	{
		if(!empty($_POST['col1'])) $header[0] = t(getColumns($_POST['col1'], 'Header'));
		if(!empty($_POST['col2'])) $header[1] = t(getColumns($_POST['col2'], 'Header'));
		if(!empty($_POST['col3'])) $header[2] = t(getColumns($_POST['col3'], 'Header'));
		if(!empty($_POST['col4'])) $header[3] = t(getColumns($_POST['col4'], 'Header'));
		if(!empty($_POST['col5'])) $header[4] = t(getColumns($_POST['col5'], 'Header'));
		if(!empty($_POST['col6'])) $header[5] = t(getColumns($_POST['col6'], 'Header'));
	}	
	if(is_array($header))
	{
		dbconnect();
		if($_POST['usequery'] == 'true')
		{
			$sql = $_SESSION['list_sql'];
		}
		else
		{
			$sql = 'select distinct id from pmp_filme';
			if(! $_POST['sortby'] == "0") 
			{
				$sql .= ' order by ';

				if($_POST['sortby'] == 1) $sql .= 'title';
				if($_POST['sortby'] == 2) $sql .= 'year';
				if($_POST['sortby'] == 3) $sql .= 'location';
				if($_POST['sortby'] == 4) $sql .= 'number';
				if($_POST['sortby'] == 5) $sql .= 'kaufdatum';
				if($_POST['sortby'] == 6) $sql .= 'laenge';
				if($_POST['sortby'] == 7) $sql .= 'preis';
				if($_POST['sortby'] == 8) $sql .= 'kaufort';
				if($_POST['sortby'] == 9) $sql .= 'edition';
				
				if($_POST['sortdir'] == "asc") $sql .= ' asc';
				elseif($_POST['sortdir'] == "desc") $sql .= ' desc';
			}
		}
		
		$res = dbexec($sql);
		if($_POST['report'] == 'html')
		{
			$columnoutput = 'Output';
		}
		else
		{
			$columnoutput = 'AltOutput';
		}
	
		while($row = mysql_fetch_object($res))
		{
			$dvd = new smallDVD($row->id);
			if(!empty($_POST['col1'])) $tmpdata[0] = decode_entities($dvd->get(getColumns($_POST['col1'], $columnoutput)));
			if(!empty($_POST['col2'])) $tmpdata[1] = decode_entities($dvd->get(getColumns($_POST['col2'], $columnoutput)));
			if(!empty($_POST['col3'])) $tmpdata[2] = decode_entities($dvd->get(getColumns($_POST['col3'], $columnoutput)));
			if(!empty($_POST['col4'])) $tmpdata[3] = decode_entities($dvd->get(getColumns($_POST['col4'], $columnoutput)));
			if(!empty($_POST['col5'])) $tmpdata[4] = decode_entities($dvd->get(getColumns($_POST['col5'], $columnoutput)));
			if(!empty($_POST['col6'])) $tmpdata[5] = decode_entities($dvd->get(getColumns($_POST['col6'], $columnoutput)));
			unset($dvd);
			
			$data[] = array_map("decode_entities", $tmpdata);
		}

		if($_POST['report'] == 'html')
		{
			require_once('../include/pmp_Smarty.class.php');
			require_once('include/option.class.php');
	
			$smarty = new pmp_Smarty;
			$smarty->compile_dir ='../templates_c';
			
			$smarty->assign('header', t('DVD list'));
			$smarty->assign('header_img', 'report');
			$smarty->assign('session', session_name() . "=" . session_id() );
			
			$smarty->assign('headers', $header);
			$smarty->assign('data', $data);
	
			$smarty->display('admin/report_list.tpl');
		}
		elseif($_POST['report'] == 'pdf')
		{
			$pdf=new PDF();
			$pdf->AddPage();
			$pdf->generateReport($header, $colwidth, $data);
			$pdf->Output();
		}
	}
	else
	{
		require_once('../include/pmp_Smarty.class.php');
		require_once('include/option.class.php');

		$smarty = new pmp_Smarty;
		$smarty->compile_dir ='../templates_c';
		
		$smarty->assign('header', t('Report'));
		$smarty->assign('header_img', 'report');
		$smarty->assign('session', session_name() . "=" . session_id() );

		$spalten[] = new option('col1', 'Column 1', '', $pmp_menue_spalte_1, getColumnsasOption());
		$spalten[] = new option('col2', 'Column 2', '', $pmp_menue_spalte_2, getColumnsasOption());
		$spalten[] = new option('col3', 'Column 3', '', $pmp_menue_spalte_3, getColumnsasOption());
		$spalten[] = new option('col4', 'Column 4', '', $pmp_menue_spalte_4, getColumnsasOption());
		$spalten[] = new option('col5', 'Column 5', '', $pmp_menue_spalte_5, getColumnsasOption());
		$spalten[] = new option('col6', 'Column 6', '', $pmp_menue_spalte_6, getColumnsasOption());

		$smarty->assign('spalten', $spalten);
	
		$smarty->display('admin/report.tpl');
	}
		
?> 	

