<?php

	// Set version
	$pmp_version = '0.9.6';
	
	// Suppress notices
	error_reporting(E_ALL ^ E_NOTICE);
	
	// Start session if there's none
	if(!session_id()) {
		@session_start();
	}	
	
	// Check language
	if(!empty($_GET['lang_id'])) { // The user wants to change language
		// Save the information to session
		$_SESSION['lang_id'] = $_GET['lang_id'];	
	}
	// okay, the user doesn't want to change the language. Then use the language
	// from the Session. Oh, there is no language in the session?
	elseif(empty($_SESSION['lang_id'])) {
		// We need PEAR:HTTP to get the right langueage from the browser.
	 	require_once($pmp_rel_path . '/include/PEAR/HTTP.php');
	 	
	 	// This are the languages we support. Left the official language-code, right our.
		$langs = array( 'en'   => 'en',
										'en-US'=> 'en',
										'en-UK'=> 'en',
										'de'   => 'de',
										'de-DE'=> 'de',
										'de-AT'=> 'de',
										'no'	 => 'no',
										);
	
		$_SESSION['lang_id'] = $langs[HTTP::negotiateLanguage($langs, $pmp_lang_default)];
	}
		
	// Connect to the database 
	// Dies on error (with an error message) if $dieonerror is true
	function dbconnect($dieonerror = True) 
	{
		global $sqlhost, $sqluser, $sqlpass, $sqldatabase;
		global $pmp_mysql_version, $pmp_mysql_int_version;
	
		$db = @mysql_connect($sqlhost, $sqluser , $sqlpass);
	
		// Can't connect to the mysql-database
		if(!$db && $dieonerror)	{
			$the_error .= "\nmySQL error: ".mysql_error()."\n";
			$the_error .= "mySQL error code: ".mysql_errno()."\n";
			$the_error .= "Date: ".date("Y-m-d\TH:i:s"); 
			echo "<html><head><title>Datenbase Error</title><style>P,BODY{ font-family:arial,sans-serif; font-size:11px; }</style></head><body>    		   &nbsp;<br><br><blockquote><b>There appears to be an error with the database.</b><br>You can try to refresh the page by clicking <a href=\"javascript:window.location=window.location;\">here</a>, if this does not fix the error, please connect the Webmaster    		   <br><br><b>Error returned:</b><br>    		   <form name='mysql'><textarea rows=\"15\" cols=\"45\">".htmlspecialchars($the_error)."</textarea></form><br></blockquote></body></html>" ;
			exit();
		}
	
		$db_select = @mysql_select_db($sqldatabase);
		
		// Can't switch to the database
		if(!$db_select && $dieonerror) {
			$the_error .= "\nmySQL error: ".mysql_error()."\n";
			$the_error .= "mySQL error code: ".mysql_errno()."\n";
			$the_error .= "Date: ".date("Y-m-d\TH:i:s"); 
			echo "<html><head><title>Datenbase Error</title><style>P,BODY{ font-family:arial,sans-serif; font-size:11px; }</style></head><body>    		   &nbsp;<br><br><blockquote><b>There appears to be an error with the database.</b><br>You can try to refresh the page by clicking <a href=\"javascript:window.location=window.location;\">here</a>, if this does not fix the error, please connect the Webmaster    		   <br><br><b>Error returned:</b><br>    		   <form name='mysql'><textarea rows=\"15\" cols=\"45\">".htmlspecialchars($the_error)."</textarea></form><br></blockquote></body></html>" ;
			exit();
		}
		
		// We're connected, let's find out what mysql version
		// This was inspired by phpMyAdmin
		if($db && $db_select) {
			$result = dbexec('SELECT VERSION() AS version');
			if ($result && @mysql_num_rows($result) > 0) {
				$row = mysql_fetch_object($result);
				$version = explode('.', $row->version);
			}		
			if(!isset($row)) {
				$pmp_mysql_int_version = 32332;
				$pmp_mysql_version = '3.23.32';
			} else {
				$pmp_mysql_int_version = (int)sprintf('%d%02d%02d', $version[0], $version[1], intval($version[2]));
				$pmp_mysql_version = $row->version;
			}
		}
		return ($db && $db_select);
	}
	
	// Replace the table prefix and executes the query
	// If $continueonerror is set to true the script will abort with an error message if the query fails.
	function dbexec($sql, $continueonerror = False) 
	{
		$sql = replace_table_prefix($sql);
		$result = @mysql_query($sql);
		
		if(!$continueonerror) {
			if(!$result) {
				echo "<strong>SQL-Statement failed:</strong><br /><pre>" . mysql_errno() . " - " . mysql_error() . "\n\nQuery:\n$sql</pre>";
				die;
			}
		}
		return $result;
	}
	
	// Espaces character in sql values (' => \')
	function escape_sql($str) 
	{
		return str_replace('\'', '\\\'', $str);
	}
	
	// Close database
	function dbclose() 
	{
		mysql_close();
	}
	
	// Replace the tableprefix pmp_ with the user defined prefix
	function replace_table_prefix($sql) 
	{	
		global $pmp_table_prefix;
		return str_replace('pmp_', $pmp_table_prefix, $sql);
	}
	
	// Not everybody have PHP5
	if (!function_exists('file_put_contents')) {	
		if (!defined('FILE_APPEND')) {	
			define('FILE_APPEND', 8); 
	  	} 
	  	if (!defined('FILE_USE_INCLUDE_PATH')) { 
	  		define('FILE_USE_INCLUDE_PATH', 1); 
	 	} 
	 	function file_put_contents($filename, $data, $flags = 0) 
	 	{ 
	  		$mode = $flags & FILE_APPEND ? 'ab' : 'wb'; 
	    	$fh = fopen($filename, $mode, $flags & FILE_USE_INCLUDE_PATH); 
	   		$bytes_written = fwrite($fh, $data); 
	    	fclose($fh); 
	    	return $bytes_written; 
	 	}
	} 
	
	// and not everybody have PHP >=4.3
	if (!function_exists('file_get_contents')) {
		function file_get_contents($file) 
		{
			$v = file($file);
			return ($v) ? implode('', $v) : false;
		}
	}
	
	// Cut $string after $length character and add the $suffix
	// Will pay attention to things like &uuml;
	function trunc($string, $length, $suffix = '...') 
	{ 
		if(strlen($string) - strlen($suffix) > $length)	{
			if(strpos($string, '&', $length-5) && strpos($string, '&', $length-5) < $length) { 
				return trunc($string, $length + (strpos($string, ';', $length-5) -strpos($string, '&', $length-5)), $suffix);
			} else {
				return substr($string,0,$length) . $suffix;
			}
		} else {
			return $string;
		}
	}
	
	// Replace all html-entities with the right special characters
	function decode_entities($text) 
	{
		$text= str_replace('&apos;', "'", $text);
		$text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-1"); 
		$text= preg_replace('/&#(\d+);/me',"chr(\\1)",$text); 
		$text= preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)",$text);  
		return $text;
	}
	
	// Replace all special characters with the right html-entities
	function encode_entities($string) 
	{
		if (!isset($trans)) {
			$trans = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
			foreach ($trans as $key => $value) {
				$trans[$key] = '&#'.ord($key).';';
				// dont translate the '&' in case it is part of &xxx;
				$trans[chr(38)] = '&';
	   		}
			// after the initial translation, _do_ map standalone '&' into '&#38;'
			return preg_replace("/&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,3};)/","&#38;" , strtr($string, $trans));
		}
	}
	
	function getColumns($spalte = '', $detail = '') 
	{
		$spalten[0]['Header'] = ''; // displayed name of the column 
		$spalten[0]['Output'] = ''; // object-property/function to display
		$spalten[0]['Sort'] = 'Hide column';  // The datebase field to sort
	
		$spalten[1]['Header'] = 'Movie title';
		$spalten[1]['Output'] = 'Titel';
		$spalten[1]['Sort'] = 'sort';
		
		$spalten[2]['Header'] = 'Year';
		$spalten[2]['Output'] = 'Jahr';
		$spalten[2]['Sort'] = 'year';
	
		$spalten[3]['Header'] = 'Country';
		$spalten[3]['Output'] = 'getLocationFlag';
		$spalten[3]['AltOutput'] = 'Location';  // altenative Text output (eg for pdfs)
		$spalten[3]['Sort'] = "substr([tab]id, instr([tab]id, '.'))";
		
		$spalten[4]['Header'] = 'Nr.';
		$spalten[4]['Output'] = 'Nummer';
		$spalten[4]['Sort'] = 'number';
	
		$spalten[5]['Header'] = 'Date of purchase';
		$spalten[5]['Output'] = 'Kaufdatum';
		$spalten[5]['Sort'] = 'Kaufdatum';
		
		$spalten[6]['Header'] = 'Length';
		$spalten[6]['Output'] = 'Laenge';
		$spalten[6]['Sort'] = 'Laenge';
		
		$spalten[7]['Header'] = 'Price';
		$spalten[7]['Output'] = 'Preis';
		$spalten[7]['Sort'] = 'preis';
		
		$spalten[8]['Header'] = 'Place of purchase';
		$spalten[8]['Output'] = 'Kaufort';
		$spalten[8]['Sort'] = 'Kaufort';
	
		$spalten[9]['Header'] = 'Edition';
		$spalten[9]['Output'] = 'Edition';
		$spalten[9]['Sort'] = 'edition';	
		
		if(empty($spalte)) {
			return $spalten;
		} elseif(empty($detail)) {
			return $spalten[$spalte];
		} elseif($detail == 'AltOutput' && !isset($spalten[$spalte][$detail])) {
			return $spalten[$spalte]['Output'];
		} else {
			return $spalten[$spalte][$detail];
		}
	}
	
	function getColumnsasOption() 
	{
		foreach(getColumns() as $key => $spalte) {
			$ret[$key] = $spalte['Header'];
		}
		return $ret;
	} 
	
	function getFlagName($state) 
	{
	  	// German country names
		$flags['deutschland'] = 'Germany.gif';
		$flags['usa'] = 'USA.gif';
		$flags['england'] = 'Great_Britain.gif';
		$flags['holland'] = 'Netherlands.gif'; 
		$flags['schweiz'] = 'Switzerland.gif';
		$flags['oesterreich'] = 'Austria.gif';
		$flags['kanada'] = 'Canada.gif';
		$flags['suedkorea'] = 'South_Korea.gif';
		$flags['japan'] = 'Japan.gif'; 
		$flags['china'] = 'China.gif'; 
		$flags['australien'] = 'Australia.gif';
		$flags['schweden'] = 'Sweden.gif';
		$flags['daenemark'] = 'Denmark.gif'; 
		$flags['finnland'] = 'Finland.gif'; 
		$flags['norway'] = 'Norway.gif'; 
		$flags['polen'] = 'Poland.gif'; 
		$flags['griechenland'] = 'Greece.gif';
		$flags['frankreich'] = 'France.gif';
		$flags['spanien'] = 'Spain.gif';
		$flags['hong kong'] = 'Hong_Kong.gif'; 
		$flags['italien'] = 'Italy.gif';
		$flags['neuseeland'] = 'New_Zealand.gif';
		$flags['portugal'] = 'Portugal.gif';
		$flags['kanada(quebec)'] = 'Canada_Q.gif';
		$flags['suedafrika'] = 'South_Africa.gif';
		$flags['mexico'] = 'Mexico.gif';
		$flags['ehm. sowietunion'] = 'Russia.gif';
		$flags['island'] = 'Iceland.gif';
		$flags['brasilien'] = 'Brazil.gif';
		$flags['israel'] = 'Israel.gif';
		$flags['indonesien'] = 'Indonesia.gif';
		
		// international codes
		$flags['de'] = 'Germany.gif';
		$flags['us'] = 'USA.gif';
		$flags['gb'] = 'Great_Britain.gif';
		$flags['nl'] = 'Netherlands.gif'; 
		$flags['ch'] = 'Switzerland.gif';
		$flags['at'] = 'Austria.gif';
		$flags['ca'] = 'Canada.gif';
		$flags['kr'] = 'South_Korea.gif';
		$flags['jp'] = 'Japan.gif'; 
		$flags['cn'] = 'China.gif'; 
		$flags['au'] = 'Australia.gif';
		$flags['se'] = 'Sweden.gif';
		$flags['dk'] = 'Denmark.gif'; 
		$flags['fi'] = 'Finland.gif'; 
		$flags['no'] = 'Norway.gif'; 
		$flags['pl'] = 'Poland.gif'; 
		$flags['gr'] = 'Greece.gif';
		$flags['fr'] = 'France.gif';
		$flags['es'] = 'Spain.gif';
		$flags['hk'] = 'Hong_Kong.gif'; 
	
		// English language
		$flags['en'] = '_english.gif'; 
		
		return $flags[strtolower($state)];
	}
	
	// Adds a dot after 3 charaters (10000=>10.000)
	function lp($zahl) 
	{  
	   $len = strlen($zahl); 
	   $pos = $len -3; 
	   while($pos>0) { 
	     $zahl = substr($zahl, 0,$pos).".".substr($zahl,$pos,$len-$pos+1); 
	      $pos = $pos -3; 
	   } 
	  return $zahl; 
	 }
	 
	// Counts the visit of a user with a reload lock of two hours
	// If a film id is given the access to a film is counted
	function inccounter($filmid = '') 
	{
		if(!session_id()) {
			@session_start();
		}	
		
		$sid = session_id();
	
		if($filmid != '') {	
			$sql = "select count(*) as cnt from pmp_counter_profil where sid = '" . escape_sql($sid) . "' and now() < date_add(datum, INTERVAL 2 HOUR) and film_id = '" . escape_sql($filmid) . "'";
			$result = dbexec($sql);
	
			if(mysql_result($result, 0) == 0) {
				$query = "insert into pmp_counter_profil (datum, film_id, sid) VALUES (now(),'" . escape_sql($filmid) . "', '" . escape_sql($sid) . "')";
				$result = dbexec($query);
			}
			
			$query = "SELECT count(*) as count_alle from pmp_counter_profil where film_id = '" . escape_sql($filmid) . "'";
			$result = dbexec($query);
			$alle = mysql_result($result,0,"count_alle");
			
			$query = "SELECT count(*) as count_heute from pmp_counter_profil where datum like concat(CURRENT_DATE, '%') and film_id = '" . escape_sql($filmid) . "'";
			$result = dbexec($query);
			$heute = mysql_result($result,0,"count_heute");
	  }	else {
			$sql = "select count(*) as cnt from pmp_counter where sid = '" . escape_sql($sid) . "' and now() < date_add(datum, INTERVAL 2 HOUR)";
			$result = dbexec($sql);
	
			if(mysql_result($result, 0) == 0) {
				$query = "Insert into pmp_counter (datum, sid) VALUES ( now(), '" . escape_sql($sid) . "')";
				$result = dbexec($query);
			}  	
			
			$query = "SELECT count(*) as count_alle from pmp_counter";
			$result = dbexec($query);
			$alle = mysql_result($result,0,"count_alle");
			
			$query = "SELECT count(*) as count_heute from pmp_counter where datum like concat(CURRENT_DATE, '%') ";
			$result = dbexec($query);
			$heute = mysql_result($result,0,"count_heute");
		}
		return array('alle' => $alle, 'heute' => $heute);
	}
	
	// Translates $string. If array $args is given, the values will replaced.
	//
	// Example:
	//
	// echo t("Hallo %u. How are you?",  array("%u" => 'Frank'));
	//
	// Output: "Moin Frank. Wie geht es dir?"
	function t($string, $args = array()) 
	{ 
		global $lang_data, $_SESSION; 
	    
	 	if(!@count($lang_data)) {
	   		getLang($_SESSION['lang_id']); 
		} 
		if(empty($lang_data[$string])){
			return strtr($string, $args);
		// uncomment this line if you want to search missing translations
		//		return '<strong style="color:red">Missing:</strong> ' . strtr($string, $args);
		} else {
	  	return strtr($lang_data[$string], $args);
		}
	} 
	
	// Loads the translations from XML file
	function getLang ($lang_id) 
	{
		global $lang_data, $pmp_rel_path, $pmp_theme;
		
		// First we load the language-file from default
		$data = file_get_contents($pmp_rel_path . '/themes/default/locale/'. $lang_id . '.xml');
			
		while(strpos($data, '<message')) {
			$tmp = gettween($data, '<message', '</message>');
			$lang_data[gettween($tmp, '<id>', '</id>')] = gettween($tmp, '<string>', '</string>');
			$data = substr($data, strpos($data, '</message>') + 10);
		}
		
		// Now we add and replace the translations from the theme
		$data = file_get_contents($pmp_rel_path . '/themes/' . $pmp_theme . '/locale/'. $lang_id . '.xml');
			
		while(strpos($data, '<message')) {
			$tmp = gettween($data, '<message', '</message>');
			$lang_data[gettween($tmp, '<id>', '</id>')] = gettween($tmp, '<string>', '</string>');
			$data = substr($data, strpos($data, '</message>') + 10);
		}
	}
	
	// Extract the part between $after an $before
	function gettween($string, $after, $before) 
	{
		$start = strpos($string, $after) + strlen($after);
		$stop = strpos($string, $before);
		return substr($string, $start, $stop-$start);
	}
	
	// Return all supported languages.
	function getLangs() 
	{
		global $pmp_rel_path, $pmp_theme;
		
		$dir = $pmp_rel_path . '/themes/' . $pmp_theme . '/locale';
		$handle = opendir ($dir);
		
		while (false !== ($file = readdir ($handle)))
		{
			if(is_file($dir . '/' . $file))
			{
	    	$lg[] = str_replace('.xml', '', $file);
	    }
	  	
		}
		closedir($handle);	
		
		return $lg;
	}
	
	function translatelocation($code) 
	{
		switch($code) {
			case  0: return "USA"; break;
			case  1: return "Neuseeland"; break;
			case  2: return "Australien"; break;
			case  3: return "Kanada"; break;
			case  4: return "England"; break;
			case  5: return "Deutschland"; break;
			case  6: return "China"; break;
			case  7: return "ehm. Sowietunion"; break;
			case  8: return "Frankreich"; break;
			case  9: return "Holland"; break;
			case 10: return "Spanien"; break;
			case 11: return "Schweden"; break;
			case 12: return "Norway"; break;
			case 13: return "Italien"; break;
			case 14: return "Daenemark"; break;
			case 15: return "Portugal"; break;
			case 16: return "Finnland"; break;
			case 17: return "Japan"; break;
			case 18: return "Suedkorea"; break;
			case 19: return "Kanada(Quebec)"; break;
			case 20: return "Suedafrika"; break;
			case 21: return "Hong Kong"; break;
			case 22: return "Schweiz"; break;
			case 23: return "Brasilien"; break;
			case 24: return "Israel"; break;
			case 25: return "Mexico"; break;
			case 26: return "Island"; break;
			case 27: return "Indonesien"; break;
		}
		
	}
	// If no PHP5 available:
	if(!function_exists('array_combine')) {
		function array_combine($a, $b) 
		{
			$c = array();
			$at = array_values($a);
			$bt = array_values($b);
			foreach($at as $key=>$aval) $c[$aval] = $bt[$key];
			return $c;
	  }
	}
	
	function checkDBState()
	{
		global $pmp_rel_path;
		
		// Get Version of Database
			
		$sql= "select id, zeit from pmp_update order by id desc limit 1";
		$res = dbexec($sql, True);
		
		if($res) {
			$row = mysql_fetch_object($res);
			$StandDB = $row->id;
			$StandDBZeit = $row->zeit;
		} else {
			$StandDB = -1;
			$StandDBZeit = -1;
		}
	
		// Look for updates
		$StandUpdate = -1;
	
		$handle=opendir ($pmp_rel_path . '/admin/updates');
		while (false !== ($file = readdir ($handle))) {
			if($file != '.' && $file != '..' && !is_dir($file))	{
				$tmp = explode('.', $file);
				
				if($tmp[count($tmp)-1] == 'upd') {
					if($tmp[0] > $StandUpdate) {
						$StandUpdate = $tmp[0];
					}
	   			}
	   		}
		}
		closedir($handle);
		return array('StateUpdate'  => $StandUpdate,
					 'StateDB' 		=> $StandDB,
					 'StateDBTime'  => $StandDBZeit);
	}
	
	// Update rates vom ECB
	function updateRates() 
	{
		$xmlrates = file_get_contents('http://www.ecb.int/stats/eurofxref/eurofxref-daily.xml');
	
		preg_match("/<Cube time='(.*)'>/i", $xmlrates,  $date);
		preg_match_all("/<Cube currency='(.*)' rate='(.*)'/i", $xmlrates,  $tmp);
		$rates = array_combine($tmp[1], $tmp[2]);
		
		foreach($rates as $curr=>$rate) {
			dbexec('insert into pmp_rates (id, rate, date) values (\'' . $curr . '\', ' . $rate . ', \'' . $date[1] . '\')');
		}
	}	
	
	// Converts currenty $from to $to
	function exchange($from, $to, $value) 
	{
		if($from == 'EUR') {
			$ratefrom = 1;
		} else {
			$ratefrom = @mysql_result(dbexec('select rate from pmp_rates where id = \'' . $from . '\''), 0);
		}
		if($to == 'EUR') {
			$rateto = 1;
		} else {
			$rateto = mysql_result(dbexec('select rate from pmp_rates where id = \'' . $to . '\''), 0);
		}
		if(is_numeric($ratefrom) && is_numeric($rateto)) {
			return sprintf("%01.2f", $rateto * $value / $ratefrom);
		} else {
			return -1;
		}
	}
	
	// get a list of all currencies in the database. If there is no database-access use default list.
	function getCurrencies() 
	{
		// Let's try to connect....
		dbconnect(False);
		$res = dbexec('select id from pmp_rates order by id', true);
		
		// The Euro is not in the list, because it's the base currency
		$rates['EUR'] = 'EUR';
	
		if($res) {
			if (mysql_num_rows($res) > 0) {
				while($row = mysql_fetch_object($res)) {
					$rates[$row->id] = $row->id;
				}
			}
		} else {  // no access to database, use default values
			$rates['USD'] = 'USD';
			$rates['JPY'] = 'JPY';
			$rates['CYP'] = 'CYP';
			$rates['CZK'] = 'CZK';
			$rates['DKK'] = 'DKK';
			$rates['EEK'] = 'EEK';
			$rates['GBP'] = 'GBP';
			$rates['HUF'] = 'HUF';
			$rates['LTL'] = 'LTL';
			$rates['LVL'] = 'LVL';
			$rates['MTL'] = 'MTL';
			$rates['PLN'] = 'PLN';
			$rates['SEK'] = 'SEK';
			$rates['SIT'] = 'SIT';
			$rates['SKK'] = 'SKK';
			$rates['CHF'] = 'CHF';
			$rates['ISK'] = 'ISK';
			$rates['NOK'] = 'NOK';
			$rates['BGN'] = 'BGN';
			$rates['HRK'] = 'HRK';
			$rates['RON'] = 'RON';
			$rates['RUB'] = 'RUB';
			$rates['TRY'] = 'TRY';
			$rates['AUD'] = 'AUD';
			$rates['CAD'] = 'CAD';
			$rates['CNY'] = 'CNY';
			$rates['HKD'] = 'HKD';
			$rates['IDR'] = 'IDR';
			$rates['KRW'] = 'KRW';
			$rates['MYR'] = 'MYR';
			$rates['NZD'] = 'NZD';
			$rates['PHP'] = 'PHP';
			$rates['SGD'] = 'SGD';
			$rates['THB'] = 'THB';
			$rates['ZAR'] = 'ZAR';
		}
		
		return $rates;
	}
	
	function getThemes() 
	{
		global $pmp_rel_path;
		require_once('include/theme.class.php');
	
		if ($handle = opendir($pmp_rel_path . '/themes')) {
	   		while (false !== ($file = readdir($handle))) {
				if ($file != "." && $file != "..") {
					$tmp = new theme($file);
					if($tmp->id !== False) {
						$res[] = $tmp;
	          		}
	        	}
			}
	 	}	
		closedir($handle);
		return $res;
	}
		
	function isadmin() 
	{
		$_SESSION['lastside'] = $_SERVER['PHP_SELF'];	
		if(empty($_SESSION['isadmin']))	{
			header("Location:login.php?" . session_name() . "=" . session_id() );
		}
	}
		
	function showtextintags($text) 
	{
		$text = preg_replace("/(\<script)(.*?)(script>)/si", "dada", "$text");
		$text = strip_tags($text);
		$text = str_replace("<!--", "&lt;!--", $text);
		$text = preg_replace("/(\<)(.*?)(--\>)/mi", "".nl2br("\\2")."", $text);
		$text = addslashes($text);
		return $text;
	}
	
	// This is a replacement for glob on servers that are running a php version < 4.3
	// by x_terminat_or_3 at yahoo dot country:fr
	if(!(function_exists('glob'))) {
		function glob($pattern)
		{
			// get pathname (everything up until the last / or \)
			$path = null;
			$output = null;
			if(PHP_OS == 'WIN32') {
				$slash='\\';
			} else {
				$slash='/';
			}
			$lastpos = strrpos($pattern, $slash);
			if(!($lastpos === false)) {
				$path = substr($pattern, 0, -$lastpos-1); // negative length means take from the right
				$pattern = substr($pattern, $lastpos);
			} else {
				// no dir info, use current dir
			 	$path = getcwd();
			}
			$handle = @opendir($path);
			if($handle === false) {
				return false;
			}
			while($dir = readdir($handle)) {
				if(pattern_match($pattern, $dir))
				$output[] = $dir;
			}
			closedir($handle);
			
			if(is_array($output)) {
				return $output;
			}
			return false;
	 }
	
		function pattern_match($pattern, $string)
		{
			// basically prepare a regular expression
			$out = null;
			$chunks = explode(';', $pattern);
			foreach($chunks as $pattern) {
				$escape=array('$', '^', '.', '{', '}', '(', ')', '[', ']', '|');
				while(strpos($pattern, '**') !== false) {
					$pattern = str_replace('**', '*', $pattern);
				}
				
				foreach($escape as $probe) {
					$pattern=str_replace($probe,"\\$probe",$pattern);
				}
			 	$pattern = str_replace('?*', '*', str_replace('*?','*', str_replace('*',".*", str_replace('?', '.{1,1}', $pattern))));
			 	$out[]=$pattern;
			}
			if(count($out) == 1) {
			 return(eregi("^$out[0]$",$string));
			} else {
				foreach($out as $tester) {
					if(eregi("^$tester$",$string)) {
						return true;
					}
				return false;
				}
			}
		}
	}
?>