<?php 
// Aurufmglichkeiten:
//
// ?reset=1				
//		Entfernt alle Filter und Sortierungen
// ?page=foo			
//		Zeigt Seite foo an
//
// Sortieren:
// ==========
//
// ?orderby=foo&orderdir=[asc|desc] 
//		Sortiert nach foo mir richtung orderdir. Falls kein orderdir angegeben wurde, wir desc benutzt.
//
// Filtern:
// ========
//
// ?delwhere=foo	
//		Entfernt alle Filter fr Tabellenfeld foo
// ?delwhere=foo&whereval=bar 
//		Enfernte den Filter bar fr das Feld foo
// ?addwhere=foo&whereval=bar 
//		Fgt einen Filter fr das Feld foo mit em Wer bar hinzu
// ?addwhere=foo&delwhere=foo&whereval=bar 
//		Fgt einen Filter fr das Feld foo mit em Wer bar hinzu und lscht vorher alle anderen Filter fr foo
//
// weitere Optionen fr addwhere:
//		?caption=qux 
//			Gibt dem Filter die Bezeichnung qux. 
//		?trim=True 
//			Entfernt berflssige Zeichen ("whitespace") am Anfang und Ende vom whereval
//		?addwildcardafter=True 
//			Hngt whereval ein % an
//		?addwildcardbefore=True 
//			Stellt whereval ein % voran
//		?addwildcardboth=True 
//			Ergnze whereval vorne und hinten um ein % 
//
// Bemerkungen:
//
//	Enthlt addwhere oder orderby ein [tab], dann wird dieses durch den entsprechenden 
//	Tabellennamen("pmp_filme.") ersetzt.
//
//	Enthlt irgendein Parameter ein [dot], dann wird dieses durch . ersetzt
//
//	Tabellen-Joins:
//
//	?addwhere=fremdtabelle.ref_feld&whereval=fremdfeld.wertfremdfeld
//			wrde ergeben:
//		inner join fremdtabelle t1 on pmp_filme.id = t1.ref_feld and t1.fremdfeld = 'wertfremdfeld'
//
//		fremdtabelle: 	Tabelle mit der Verknpft werden soll
//		ref_feld:				Feld in der Fremdtabelle, das auf pmp_filme.id zeigt
//		fremdfeld:			Feld, nach dem in der Fremdtabelle gefiltert werden sollte (zb Genre)
//		wertfremdfeld:	Wert, nach dem im fremdfeld gefiltert werden soll (zb Comedy)
//		

	$pmp_rel_path = '.';
	$pmp_module = 'list';
	require_once('config.inc.php');
	require_once("functions.php");
	require_once('include/pmp_Smarty.class.php');
	require_once('include/smallDVD.class.php');

	dbconnect();

	$smarty = new pmp_Smarty;
	$smarty->plugins_dir = 'include/plugin/';

	if(!session_id()) 
	{
		@session_start();
	}	

	function generateSql($count = False)
	{	
		global $_GET, $_SESSION, $menueseite;
		
		// SQL aufbauen
  	
		$join[] = 'left join pmp_boxset on pmp_filme.id=pmp_boxset.child_id';
		$j = 0;
		if(isset($_SESSION['list_where']))
		{
			foreach($_SESSION['list_where'] as $feld => $val)
			{
				if(strpos($val['field'], '.'))
				{
					$tmp1 = explode('.', $val['field']);
					$tmp2 = explode('.', $val['value']);
					$j++;
					$join[] = 'inner join ' . $tmp1[0] . " t$j on pmp_filme.id = t$j." . $tmp1[1];
					$where[] = "t$j." .$tmp2[0] ." = '" . escape_sql($tmp2[1]) . "'";
				}
				else
				{
					if((strpos($val['field'], '[tab]') === False))
					{
						$val['field'] = 'pmp_filme.' . $val['field'];
					}
					else
					{
						$val['field'] = str_replace('[tab]', 'pmp_filme.', $val['field']);
					}
					
					
					if((strpos($val['value'], '_') !== False) || (strpos($val['value'], '%') !== False))
					{
						
						$where[] = $val['field'] . " like '" . escape_sql($val['value']) . "'";
					}
					else
					{
						$where[] = $val['field'] . " = '" . escape_sql($val['value']) . "'";
					}                                           
				}                                             
			}                                               
		}                                                 
  	                                                  
		$where[] = 'pmp_boxset.child_id is null';
		
		$zwisql  = implode(" \n", $join) . " \n";
		$zwisql .= 'where ' . implode(" and \n", $where) . " \n";
		
		if(!$count)
		{
			$sql  = 'select distinct pmp_filme.id from pmp_filme ' . $zwisql;
		
			// Save statement
			$_SESSION['list_sql'] = 'select distinct pmp_filme.id from pmp_filme ' . $zwisql;
			
		}
		else
			$sql  = 'select count(distinct pmp_filme.id ) as c from pmp_filme ' . $zwisql;

   
		if(isset($_SESSION['list_orderby']))
		{
			if((strpos($_SESSION['list_orderby'], '[tab]') === False))
			{
				$sql .= 'order by pmp_filme.' . $_SESSION['list_orderby'] . ' ' . $_SESSION['list_orderdir'] . ' ';
			}
			else
			{
				$sql .= 'order by ' . str_replace('[tab]', 'pmp_filme.', $_SESSION['list_orderby']) . ' ' . $_SESSION['list_orderdir'] . ' ';
			}
		}
		if(!$count)
		{
			$sql .= 'limit ' . ((int)$_SESSION['list_page']-1) * $menueseite . ', ' . $menueseite . ' ';
		}
		
		$sql = str_replace('[dot]', '.', $sql);

		return $sql;
	}

	// Ein paar Defaultwerte
	function setDefaultFilter()
	{
		global $_SESSION;
		if(count($_SESSION['list_where']) == 0)
		{
			$_SESSION['list_where'][] = array('field' => 'besitz', 'value' => 'Owned');
		}
  	
		if(empty($_SESSION['list_orderby']))
		{
			$_SESSION['list_orderby'] = 'sort';
			$_SESSION['list_orderdir'] = 'asc';
		}
  	
		if(empty($_SESSION['list_page']))
		{
			$_SESSION['list_page'] = 1;
		}
	}

	// Filter resetten
	if(isset($_GET['reset']))
	{
			unset($_SESSION['list_where']);	
			unset($_SESSION['list_sort']);	
			unset($_SESSION['list_page']);	
	}	
	
	// \' gegen ' ersetzen etc
	$_GET['addwhere'] = stripslashes($_GET['addwhere']);
	$_GET['delwhere'] = stripslashes($_GET['delwhere']);
	$_GET['orderby'] = stripslashes($_GET['orderby']);

	// Sortierung
	if(!empty($_GET['orderby']))
	{
		$_SESSION['list_orderby'] = strtolower($_GET['orderby']);
		if($_GET['orderdir'] == 'asc')
		{
			$_SESSION['list_orderdir'] = 'asc';
		}
		else
		{
			$_SESSION['list_orderdir'] = 'desc';
		}
	}

	// Filter lschen
	if(isset($_GET['delwhere']))
	{
		if(count($_SESSION['list_where']) > 0)
		{
			foreach($_SESSION['list_where'] as $key => $val)
			{
				if($val['field'] == $_GET['delwhere'])
				{
					if(isset($_GET['whereval']))
					{
						if($val['value'] == $_GET['whereval'] || (isset($_GET['delwhere']) && isset($_GET['addwhere'])))
						{
							unset($_SESSION['list_where'][$key]);	
						}
					}
					else
					{
						unset($_SESSION['list_where'][$key]);	
					}
					
				}
			}
		}
	}

	// Wildcards ergnzen und trimmen
	if($_GET['trim'] == 'True')
	{
		$_GET['whereval'] = trim($_GET['whereval']);
	}
	if($_GET['addwildcardafter'] == 'True')
	{
		$_GET['whereval'] = $_GET['whereval'] . '%';
	}
	if($_GET['addwildcardbefore'] == 'True')
	{
		$_GET['whereval'] = '%' . $_GET['whereval'];
	}
	if($_GET['addwildcardboth'] == 'True')
	{
		$_GET['whereval'] = '%' . $_GET['whereval'] . '%';
	}
	
	// Filter hinzufgen
	if(!empty($_GET['addwhere']) && isset($_GET['whereval']))
	{
		$found = $false;
		if(count($_SESSION['list_where']) > 0)
		{
			foreach($_SESSION['list_where'] as $key => $val)
			{
				if($val['field'] == $_GET['addwhere'])
				{
					if($val['value'] == $_GET['whereval'])
					{
						$found = true;
						break;
					}
				}
			}
		}
		
		if(!$found)				
		{
			$_SESSION['list_where'][] = array('field' => $_GET['addwhere'], 'value' => $_GET['whereval'], 'caption' => $_GET['caption']);
			$_SESSION['list_page'] = 1;
		}
	}

	setDefaultFilter();
	
	// Seite
	if(isset($_GET['page']))
	{
		$_SESSION['list_page'] = $_GET['page'];
	}
	// SQL ausfhren

	$sql = generateSql();

	$smarty->caching = $pmp_smarty_caching;
	$smarty->cache_lifetime = $pmp_cache_lifetime;

	if (!$smarty->is_cached('list.tpl', md5($sql)))
	{
		$res = dbexec($sql, True);
  	
		if($res === False)
		{
			$oldsql = $sql;
			unset($_SESSION['list_where']);
			unset($_SESSION['list_orderby']);
			setDefaultFilter();
			$sql = generateSql();
			$olderror = mysql_error();
			$res = dbexec($sql);
			$smarty->assign('Error', t('An error occurs during your query. To continue working all filters set to default values.'));
		}
  	
		while($row = mysql_fetch_object($res))
		{
			$o[] = new smallDVD($row->id);
		}
  	
		$smarty->assign('Filme', $o);
		
		// Evtl externe Filter ermitteln
		
		foreach($_SESSION['list_where'] as $feld => $val)
		{
			if(isset($val['caption']))
			{
				$extFilter[] = $val;
			}
		}
  	
		$smarty->assign('extFilter', $extFilter);
		
		
		// Anzahl 
		
		$res = dbexec(generateSql(True));
		$row = mysql_fetch_object($res);
		$dvdcount = $row->c;
  	
		$smarty->assign('DVDCount', $dvdcount);
		$smarty->assign('DVDproSeite', $menueseite);
		$smarty->assign('aktuelleSeite', (int)$_SESSION['list_page']);
		$smarty->assign('AnzahlSeiten', (int)($dvdcount / $menueseite + ((($dvdcount % $menueseite)==0)? 0 : 1)));
		
		// Locations ermitteln
		$res = dbexec('select distinct if(instr(id, \'.\'), substring(id, instr(id, \'.\')+1),0) as location from pmp_filme');
  	
		while($row = mysql_fetch_object($res))
		{
			$loc[] = array('value' => $row->location, 'caption' => translatelocation($row->location));
		}
		
		$smarty->assign('Locations', $loc);
  	
		// Tags ermitteln
		$res = dbexec('select distinct name from pmp_tags order by name');
  	
		while($row = mysql_fetch_object($res))
		{
			$tags[] = $row->name;
		}
		
		$pmp_menue_spalte_1 = getColumns($pmp_menue_spalte_1);
		$pmp_menue_spalte_2 = getColumns($pmp_menue_spalte_2);
		$pmp_menue_spalte_3 = getColumns($pmp_menue_spalte_3);
		$pmp_menue_spalte_4 = getColumns($pmp_menue_spalte_4);
		$pmp_menue_spalte_5 = getColumns($pmp_menue_spalte_5);
		$pmp_menue_spalte_6 = getColumns($pmp_menue_spalte_6);
  	
		$smarty->assign('use_combo_for_tags', $use_combo_for_tags==1);
  	
		$smarty->assign('Tags', $tags);
  	
		$smarty->assign('getLangs', getLangs());
	}

	$smarty->display('list.tpl', md5($sql));

/*	
	echo "<pre>";
	echo $sql . "\n\n\n";
	echo $oldsql . "\n\n\n";
	echo $olderror . "\n\n\n";
	
	print_r($_GET); 
	print_r($_SESSION); // */
	
?>